Index: gnu/testlet/java/lang/ref/PhantomReference/phantom.java
===================================================================
RCS file: /cvs/mauve/mauve/gnu/testlet/java/lang/ref/PhantomReference/phantom.java,v
retrieving revision 1.3
diff -u -r1.3 phantom.java
--- gnu/testlet/java/lang/ref/PhantomReference/phantom.java	18 Apr 2004 15:47:59 -0000	1.3
+++ gnu/testlet/java/lang/ref/PhantomReference/phantom.java	26 Nov 2004 14:05:42 -0000
@@ -56,14 +56,17 @@
 
     // Give the runtime some hints that it should really garbage collect.
     System.gc ();
-    Thread.yield ();
+    System.runFinalization();
     System.gc ();
+    System.runFinalization();
 
     Reference r = q.poll ();
     harness.check (r, null, "live reference");
     harness.check (final_count, 0);
 
-    // Must keep the PhantomReference live.
+    // Must keep the phantom object live.
+    System.out.println(twt);
+
     return wr;
   }
 
@@ -73,6 +76,9 @@
 
     PhantomReference wr = try1 (q, harness);
     System.gc ();
+    System.runFinalization();
+    System.gc ();
+    System.runFinalization();
 
     Reference r = null;
     try
@@ -86,5 +92,8 @@
 
     harness.check (r, wr, "unreachable");
     harness.check (final_count, 1, "object finalized");
+
+    // Make sure we're not GCed while running the test.
+    System.out.println(this);
   }
 }
